`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA02) - 4. labor                                   *
//*                                                                            *
//* 2. feladat: LED villogtat llapotgp.                                     *
//******************************************************************************
module led_blink(
   input  wire clk,
   input  wire rst,
   input  wire enable,                    //Az a) ponthoz nem szksges.
   output wire led_en
);

//Vegyl fel loklis paramterekknt az llapotokat s rendeljnk
//hozzjuk minimlis bitszm egyedi llapotkdot.
localparam LED_OFF1 = 2'd0;
localparam LED_OFF2 = 2'd1;
localparam LED_ON   = 2'd2;


//a) Valstsuk meg kzs always blokkban az llapotregisztert s a
//   kvetkez llapot logikt. Az rvnytelen llapotokbl menjnk
//   a kezdllapotba.
//b) Adjuk az llapotgphez a mkdst engedlyez enable bemenetet.
reg [1:0] state;

always @(posedge clk)
begin
   if (rst)
      state <= LED_OFF1;
   else
      case (state)
         LED_OFF1: if (enable)            //Az a) pont esetn csak
                      state <= LED_OFF2;  //state <= LED_OFF2;
                   else                   
                      state <= LED_OFF1;
         
         LED_OFF2: state <= LED_ON;
         
         LED_ON  : state <= LED_OFF1;
         
         //rvnytelen llapotok.
         default : state <= LED_OFF1;
      endcase
end


//Valstsuk meg a kimeneti logikt.
assign led_en = (state == LED_ON);


endmodule
